{
  Porovnanie Quicksortu a kombinovaneho Quicksortu
}

program QSvsCQS;

uses dos;

const vstupy=12;
      max_pocet=50000001;
      pocet_prvkov:array[1..vstupy]of longint=(10000,    20000,    50000,
                                               100000,   200000,   500000,
                                               1000000,  2000000,  5000000,
                                               10000000, 20000000, 50000000
                                              );

type pole=array[0..max_pocet]of longint;

var tabqs,tabcqs:array[1..vstupy,1..7]of string;
    testqs,testcqs:pole;
    hranica,i,j,n,k,start,finish,rozdielqs,rozdielcqs:longint;
    protokol:text;
    h,m,s,cs:word;
    vysqs,vyscqs:string;

procedure vymen(var a:pole;x,y:longint);
var z:longint;
begin
     z:=a[x];
     a[x]:=a[y];
     a[y]:=z;
end;

procedure rekqsort(var a:pole;z,k:longint);
var i,j:longint;
    p:longint;
begin
     p:=a[(z+k) div 2];
     i:=z-1;
     j:=k+1;

     repeat
	   repeat i:=i+1; until(a[i]>=p);
	   repeat j:=j-1; until(a[j]<=p);
	   if i<j then vymen(a,i,j);
     until(i>=j);

     if i=j then
     begin
	  i:=i+1;
	  j:=j-1;
     end;

     if z<=j then rekqsort(a,z,j);
     if k>=i then rekqsort(a,i,k);
end;

procedure isort(var a:pole;z,k:longint);
var i,j,pomocna:longint;
begin
     for i:=z+1 to k do
     begin
          pomocna:=a[i];
          j:=i;
          while (i>z) and (a[j-1]>=pomocna) do
          begin
               a[j]:=a[j-1];
               j:=j-1;
          end;
          a[j]:=pomocna;
     end;
end;

procedure comqsort(var a:pole;z,k:longint);
var i,j,d:longint;
    p:longint;
begin
     d:=k-z;
     if d<=hranica then isort(a,z,k)
     else
     begin
          p:=a[(z+k) div 2];
          i:=z-1;
          j:=k+1;

          repeat
	        repeat i:=i+1; until(a[i]>=p);
	        repeat j:=j-1; until(a[j]<=p);
	        if i<j then vymen(a,i,j);
          until(i>=j);

          if i=j then
          begin
	       i:=i+1;
	       j:=j-1;
          end;

          if z<=j then comqsort(a,z,j);
          if k>=i then comqsort(a,i,k);
     end;
end;

function spracuj(udaj:longint):string;
var pomoc:longint;
    r,s:string;
begin
     r:='';
     udaj:=udaj mod 360000;

     pomoc:=udaj div 6000;
     str(pomoc,s);
     if length(s)=1 then r:=r+'0'+s+':' else r:=r+s+':';
     udaj:=udaj mod 6000;

     pomoc:=udaj div 100;
     str(pomoc,s);
     if length(s)=1 then r:=r+'0'+s+'.' else r:=r+s+'.';
     udaj:=udaj mod 100;

     str(udaj,s);
     if length(s)=1 then r:=r+'0'+s else r:=r+s;
     spracuj:=r;
end;

procedure zapis_do_sub;
begin
     writeln(protokol,'Vysledky pre rekurzivny Quicksort:');
     writeln(protokol);
     writeln(protokol,'  n  \  k |    10    |    20    |    30    |    40    |    50    |    60    |    70    |');
     writeln(protokol,'----------------------------------------------------------------------------------------');
     for i:=1 to vstupy do
     begin
          write(protokol,pocet_prvkov[i]:10,'|');
          for j:=1 to 7 do write(protokol,' ',tabqs[i,j],' |');
          writeln(protokol);
          writeln(protokol,'----------------------------------------------------------------------------------------');
     end;
     writeln(protokol);
     writeln(protokol,'Vysledky pre kombinovany Quicksort a Insertsort:');
     writeln(protokol);
     writeln(protokol,'  n  \  k |    10    |    20    |    30    |    40    |    50    |    60    |    70    |');
     writeln(protokol,'----------------------------------------------------------------------------------------');
     for i:=1 to vstupy do
     begin
          write(protokol,pocet_prvkov[i]:10,'|');
          for j:=1 to 7 do write(protokol,' ',tabcqs[i,j],' |');
          writeln(protokol);
          writeln(protokol,'----------------------------------------------------------------------------------------');
     end;
end;

begin
     assign(protokol,'vystup.out');
     rewrite(protokol);
     randomize;
     for i:=1 to max_pocet do testqs[i]:=0;
     for i:=1 to max_pocet do testcqs[i]:=0;
     for i:=1 to vstupy do
     begin
          hranica:=0;
          for j:=1 to 7 do
          begin
               hranica:=hranica+10;
               n:=pocet_prvkov[i];
               for k:=1 to n do testqs[k]:=random(1000000)+1;
               for k:=1 to n do testcqs[k]:=testqs[k];
               gettime(h,m,s,cs);
               start:=h*360000+6000*m+100*s+cs;
               rekqsort(testqs,1,n);
               gettime(h,m,s,cs);
               finish:=h*360000+6000*m+100*s+cs;
               rozdielqs:=finish-start;
               gettime(h,m,s,cs);
               start:=h*360000+6000*m+100*s+cs;
               comqsort(testcqs,1,n);
               gettime(h,m,s,cs);
               finish:=h*360000+6000*m+100*s+cs;
               rozdielcqs:=finish-start;
               vysqs:=spracuj(rozdielqs);
               vyscqs:=spracuj(rozdielcqs);
               tabqs[i,j]:=vysqs;
               tabcqs[i,j]:=vyscqs;
               writeln(i,' ',j);
          end;
     end;
     zapis_do_sub;
     close(protokol);
end.