{
  Triedime 5 az 80 prvkove pole milion krat
  Algoritmy su:
  V case O(n* log n):  Quicksort, Mergesort, Heapsort,
  V case O(n*n):       Bubblesort, Insertsort, Selectsort
}

program sorty1;

uses dos;

const vstupy=16;
      max_pocet=80;
      opakovania=1000000;
      pocet_prvkov:array[1..vstupy]of longint=( 5, 10, 15, 20, 25,
                                               30, 35, 40, 45, 50,
                                               55, 60, 65, 70, 75,
                                               80);

type pole=array[0..max_pocet]of longint;

var vzor,tried:array[1..opakovania]of pole;
    tab:array[1..vstupy,1..6]of string;
    b:pole;
    velkost_haldy:longint;
    hranica,i,j,n,k,start,finish,rozdiel:longint;
    protokol:text;
    h,m,s,cs:word;
    vys:string;

procedure vymen(var a:pole;x,y:longint);
var z:longint;
begin
     z:=a[x];
     a[x]:=a[y];
     a[y]:=z;
end;

procedure qsort(var a:pole;z,k:longint);
var i,j:longint;
    p:longint;
begin
     p:=a[(z+k) div 2];
     i:=z-1;
     j:=k+1;

     repeat
	   repeat i:=i+1; until(a[i]>=p);
	   repeat j:=j-1; until(a[j]<=p);
	   if i<j then vymen(a,i,j);
     until(i>=j);

     if i=j then
     begin
	  i:=i+1;
	  j:=j-1;
     end;

     if z<=j then qsort(a,z,j);
     if k>=i then qsort(a,i,k);
end;

procedure isort(var a:pole;z,k:longint);
var i,j,pomocna:longint;
begin
     for i:=z+1 to k do
     begin
          pomocna:=a[i];
          j:=i;
          while (i>z) and (a[j-1]>=pomocna) do
          begin
               a[j]:=a[j-1];
               j:=j-1;
          end;
          a[j]:=pomocna;
     end;
end;

function spracuj(udaj:longint):string;
var pomoc:longint;
    r,s:string;
begin
     r:='';
     udaj:=udaj mod 360000;

     pomoc:=udaj div 6000;
     str(pomoc,s);
     if length(s)=1 then r:=r+'0'+s+':' else r:=r+s+':';
     udaj:=udaj mod 6000;

     pomoc:=udaj div 100;
     str(pomoc,s);
     if length(s)=1 then r:=r+'0'+s+'.' else r:=r+s+'.';
     udaj:=udaj mod 100;

     str(udaj,s);
     if length(s)=1 then r:=r+'0'+s else r:=r+s;
     spracuj:=r;
end;

procedure zapis_do_sub;
begin
     writeln(protokol,'Vysledky pre maloprvkove polia:');
     writeln(protokol);
     writeln(protokol,' n \ sort |    QS    |    MS    |    HS    |    BS    |    IS    |    SS    |');
     writeln(protokol,'-----------------------------------------------------------------------------');
     for i:=1 to vstupy do
     begin
          write(protokol,'    ');
          if pocet_prvkov[i]<10 then write(protokol,' ');
          write(protokol,pocet_prvkov[i],'    |');
          for j:=1 to 6 do write(protokol,' ',tab[i,j],' |');
          writeln(protokol);
          writeln(protokol,'-----------------------------------------------------------------------------');
     end;
end;

procedure msort(var a:pole; zac,kon:longint);
var i,j,k,p:longint;
begin
     if (kon-zac>0) then
     begin
          p:=(kon+zac) div 2;
          msort(a,zac,p);
          msort(a,p+1,kon);
          for i:=p downto zac do b[i]:=a[i];
          for j:=p+1 to kon do b[kon+p+1-j]:=a[j];
          for k:=zac to kon do
          begin
               if b[i]<b[j] then
               begin
                    a[k]:=b[i];
                    i:=i+1;
               end
               else
               begin
                    a[k]:=b[j];
                    j:=j-1;
               end;
          end;
     end;
end;

procedure bsort(var a:pole; zac,kon:longint);
var i:longint;
    zmena:boolean;
begin
     zmena:=true;
     while zmena=true do
     begin
          zmena:=false;
          for i:=zac to kon-1 do
          if a[i]>a[i+1] then
          begin
               vymen(a,i,i+1);
               zmena:=true;
          end;
     end;
end;

procedure ssort(var a:pole; zac,kon:longint);
var i,j,min:longint;
begin
     for i:=zac to kon-1 do
     begin
          min:=i;
          for j:=i+1 to kon do
          if a[j]<a[min] then min:=j;
          vymen(a,i,min);
     end;
end;

// heapsort

procedure heapify(var a:pole; i:longint);
var l,r,max:longint;
begin
     l:=2*i;
     r:=2*i+1;
     if (l<=velkost_haldy) and (a[l]>a[i]) then max:=l
     else max:=i;
     if (r<=velkost_haldy) and (a[r]>a[max]) then max:=r;
     if max<>i then
     begin
          vymen(a,i,max);
          heapify(a,max);
     end;
end;

procedure buildheap(var a:pole; n:longint);
var i,pom:longint;
begin
     velkost_haldy:=n;
     pom:=n div 2;
     for i:=pom downto 1 do heapify(a,i);
end;

procedure hsort(var a:pole; n:longint);
var i:longint;
begin
     buildheap(a,n);
     for i:=n downto 2 do
     begin
          vymen(a,1,i);
          velkost_haldy:=velkost_haldy-1;
          heapify(a,1);
     end;
end;

// samotny program

begin
     assign(protokol,'vystup.out');
     rewrite(protokol);
     randomize;
     for i:=1 to opakovania do for j:=1 to max_pocet do vzor[i][j]:=0;
     for i:=1 to opakovania do for j:=1 to max_pocet do tried[i][j]:=0;
     for i:=1 to vstupy do
     begin
          for j:=1 to opakovania do for k:=1 to max_pocet do
          vzor[j][k]:=random(1000000)+1;
          n:=pocet_prvkov[i];

          // quicksort

          for j:=1 to opakovania do for k:=1 to max_pocet do
          tried[j][k]:=vzor[j][k];
          gettime(h,m,s,cs);
          start:=h*360000+6000*m+100*s+cs;
          for j:=1 to opakovania do qsort(tried[j],1,n);
          gettime(h,m,s,cs);
          finish:=h*360000+6000*m+100*s+cs;
          rozdiel:=finish-start;
          vys:=spracuj(rozdiel);
          tab[i,1]:=vys;

          // mergesort

          for j:=1 to opakovania do for k:=1 to max_pocet do
          tried[j][k]:=vzor[j][k];
          gettime(h,m,s,cs);
          start:=h*360000+6000*m+100*s+cs;
          for j:=1 to opakovania do msort(tried[j],1,n);
          gettime(h,m,s,cs);
          finish:=h*360000+6000*m+100*s+cs;
          rozdiel:=finish-start;
          vys:=spracuj(rozdiel);
          tab[i,2]:=vys;

          // heapsort

          for j:=1 to opakovania do for k:=1 to max_pocet do
          tried[j][k]:=vzor[j][k];
          gettime(h,m,s,cs);
          start:=h*360000+6000*m+100*s+cs;
          for j:=1 to opakovania do hsort(tried[j],n);
          gettime(h,m,s,cs);
          finish:=h*360000+6000*m+100*s+cs;
          rozdiel:=finish-start;
          vys:=spracuj(rozdiel);
          tab[i,3]:=vys;

          // bubblesort

          for j:=1 to opakovania do for k:=1 to max_pocet do
          tried[j][k]:=vzor[j][k];
          gettime(h,m,s,cs);
          start:=h*360000+6000*m+100*s+cs;
          for j:=1 to opakovania do bsort(tried[j],1,n);
          gettime(h,m,s,cs);
          finish:=h*360000+6000*m+100*s+cs;
          rozdiel:=finish-start;
          vys:=spracuj(rozdiel);
          tab[i,4]:=vys;

          // insertsort

          for j:=1 to opakovania do for k:=1 to max_pocet do
          tried[j][k]:=vzor[j][k];
          gettime(h,m,s,cs);
          start:=h*360000+6000*m+100*s+cs;
          for j:=1 to opakovania do isort(tried[j],1,n);
          gettime(h,m,s,cs);
          finish:=h*360000+6000*m+100*s+cs;
          rozdiel:=finish-start;
          vys:=spracuj(rozdiel);
          tab[i,5]:=vys;

          // selectsort

          for j:=1 to opakovania do for k:=1 to max_pocet do
          tried[j][k]:=vzor[j][k];
          gettime(h,m,s,cs);
          start:=h*360000+6000*m+100*s+cs;
          for j:=1 to opakovania do ssort(tried[j],1,n);
          gettime(h,m,s,cs);
          finish:=h*360000+6000*m+100*s+cs;
          rozdiel:=finish-start;
          vys:=spracuj(rozdiel);
          tab[i,6]:=vys;

          writeln(i);
     end;
     zapis_do_sub;
     close(protokol);
end.